(function( $$ ) {
	$$.widget( "ui.menuRss", {
		options: {
			appendTo: document.documentElement,
			//appendTo: document.body,
			position: {
				my: "left top",
				at: "left bottom",
				collision: "true"
			}
		},
		_create: function() {
			var widget = this;
			var self = this.element;
			var channel = this.options.xml;
			var index = this.options.index;
			var buttonDown = this.options.buttonDown;

			buttonDown.click(function(){
				if ( widget.menu.is(":visible") ) {
					$$(".tbui-menu").hide();
					widget.close();
				} else {
					widget.open();
				}
			});

			var $rssSettings = $$("#rss-settings");
			if (!$rssSettings.val()) {
				$rssSettings = $$("<div />")
					.attr("id", "rss-settings")
					.attr("title","Настройки")
					.css({
						textAlign: 'left'
					})
					.append($$("<input class='rubar-rss-settings-input' type='checkbox' id='rubar-rss-settings-openNewTab'/>\
	<label class='rubar-rss-settings-label' for='rubar-rss-settings-openNewTab'>Открывать новостные ссылки в новом окне</label>\
	<br><label class='rubar-rss-settings-label'>Запрашивать новости раз в</label>\
	<input type='text' minValue='1' maxValue='9999' maxlength='4' class='rubar-rss-settings-input' id='rubar-rss-settings-refreshRSS' style='width:50px'/>\
	<label class='rubar-rss-settings-label'>минут</label>\
	<!--br><label class='rubar-rss-settings-label'>Ротация заголовков новостей раз в</label>\
	<input type='text' minValue='10' maxValue='9999' maxlength='4' class='rubar-rss-settings-input' id='rubar-rss-settings-rotationRSS' style='width:50px'>\
	<label class='rubar-rss-settings-label'>секунд</label-->\
	<br><label class='rubar-rss-settings-label'>Показывать</label>\
	<input type='text' minValue='5' maxValue='40' maxlength='2' class='rubar-rss-settings-input' id='rubar-rss-settings-newsCount' style='width:50px'>\
	<label class='rubar-rss-settings-label'>последних новостей</label-->")
					)
					.appendTo( $$( this.options.appendTo || "body" )[0] )
					.dialog({
						autoOpen:	false,
						width:		350,
						draggable:	false,
						resizable:	false,
						modal:		false,
						disabled:	false,
						buttons: {
							"OK": function() {
								function checkIntPref(name) {
									var val = parseInt($$('#rubar-rss-settings-' + name).val());
									var min = parseInt($$('#rubar-rss-settings-' + name).attr('minValue'));
									var max = parseInt($$('#rubar-rss-settings-' + name).attr('maxValue'));
									if (isNaN(val) || val < min) {
										$$('#rubar-rss-settings-' + name).val(min);
										return false;
									}
									if (val > max) {
										$$('#rubar-rss-settings-' + name).val(max);
										return false;
									}
									return true;
								}						
								if (!checkIntPref('refreshRSS'))
									return;
								//if (!checkIntPref('rotationRSS'))
								//	return;
								if (!checkIntPref('newsCount'))
									return;
								rubar.Pref.write('rss.opennewtab', $$('#rubar-rss-settings-openNewTab').prop('checked'));
								rubar.Pref.write('rss.refresh', parseInt($$('#rubar-rss-settings-refreshRSS').val()));
								//$.Pref.write('rss.rotation', parseInt($$('#rubar-rss-settings-rotationRSS').val()));
								rubar.Pref.write('rss.newsCount', parseInt($$('#rubar-rss-settings-newsCount').val()));
								$$(this).dialog("close");
							}, 
							"Отмена": function() { 
								$$(this).dialog("close"); 
							} 
						}
					});
			}
			this.menu = $$( "<ul />" )
				.appendTo( $$( this.options.appendTo || "body" )[0] )
				.addClass( "tbui-corner-bottom" )
				.attr("id", "rubar-rss-menu" + index)
				.css({top: 0, left: 0, position: 'fixed' })
				.zIndex("999990 !important" )
				.hide();
			this.menu.menu();
			if (channel)
				this.loadChannel(channel);
				
			function triggerCloseEvent(event) {
				if (widget.menu.is(":visible") ) {
					widget.close();
					event.originalEvent.preventDefault();
				}
			}

			$$(window).resize(triggerCloseEvent);
			//$$(window).scroll(triggerCloseEvent);
			$$(document.body).click(triggerCloseEvent);
			$$(this.menu).click(triggerCloseEvent);
		},
		open: function ( event ) {
			$$(".tbui-menu").hide();
			this.menu.appendTo( $$( this.options.appendTo || "body" )[0] )
			this.menu.show().position( $$.extend({
				of: this.element
			}, this.options.position ));
		},
		close: function( event ) {
			if ( this.menu.is(":visible") ) {
				this._trigger( "close", event );
				this.menu.hide();
			}
		},
		loadChannel: function(channel) {
			var index = this.options.index;
			$$("#rubar-rss-menu" + index).children().remove();
			this.items = $$(channel).children("item").map(function(i, item) {
				if (i >= rubar.Pref.read('rss.newsCount'))
					return null;
				else {
					return {
						label: $$(item).children('title').text(),
						hint: $$(item).children('title').text(),
						link: $$(item).children('link').text(),
					}
				}
			});
			// Add separator
			this.items.push({
				label: "",
				hint: "",
				link: "",
			});
			this.items.push({
				label: "Настройки РСС",
				hint: "Настройки РСС",
				link: "",
				callback: function(){
					//$.StatLogger.LOG_USAGE("rss");
					var opennewtab = rubar.Pref.read('rss.opennewtab');
					opennewtab = (opennewtab == '1' || opennewtab == 'true') ? true : false;
					$$('#rubar-rss-settings-openNewTab').prop('checked', opennewtab);
					$$('#rubar-rss-settings-refreshRSS').val(rubar.Pref.read('rss.refresh'));
					$$('#rubar-rss-settings-rotationRSS').val(rubar.Pref.read('rss.rotation'));
					$$('#rubar-rss-settings-newsCount').val(rubar.Pref.read('rss.newsCount'));
					$$('#rss-settings').dialog('open');
					return true;
				}
			});
			this._renderMenu( this.menu, this.items );
			this.menu.menu('refresh');
			$$('.tbui-menu-item-separator').removeClass('tbui-menu-item');
		},
		_renderMenu: function( ul, items ) {
			var self = this;
			$$.each( items, function( index, item ) {
				self._renderItem( ul, item );
			});
		},
		_renderItem: function( ul, item) {
			var $li = $$( "<li />" )
				.data( "item.menu", item )
				.append( $$( "<a />" )						
					.text( item.label )
					.attr("title", item.hint) )
				.appendTo( ul );
				if (item.label == '')
					$li.addClass('tbui-menu-item-separator')
				if (item.link != "")
					$li.click(function(){
						var newtab = rubar.Pref.read('rss.opennewtab');
						newtab = (newtab == '1' || newtab == 'true') ? true : false;
						rubar.browser.openUILink(item.link, newtab);
					});
				else if(item.callback)
					$li.click(function(){
						item.callback();
					});
			return $li;
		},
		destroy: function() {
			// In jQuery UI 1.8, you must invoke the destroy method from the base widget
			$$.Widget.prototype.destroy.call( this );
			// In jQuery UI 1.9 and above, you would define _destroy instead of destroy and not call the base method
		}
	});
})( jQ );