(function( $$ ){
	var methods = {
		show: function($node, commandFunc, index){
			var self = this;
			return this.each(function() {
				var link = decodeURIComponent($node.find('link:first').text());
				var icon = $node.find('icon:first').text();
				var caption = $node.find('caption:first').text();
				var tooltip = $node.find('tooltip:first').text();
				var guid = $node.find('guid').text();
				var id = "RubarControl" + index;
				var $button = $(this);
				$button.attr("id", id)
					.addClass('rubar-button')
					.appendTo('#RubarToolbar');				
				if (id != null)
					$button.attr("id", id);
				// image
				if (icon != '') {	
					$$('<div />')
						.attr("id", id + "_icon")
						.addClass('rubar-button-icon')
						.appendTo($button);
					loadBinContent(id + "_icon", 'data/packages/' + guid + '/' + icon);
				}
				if (caption != '') {
					$$('<p />')
						.text(caption)
						.addClass('rubar-button-caption')
						.appendTo($button);
				}
				if (tooltip != "")
					$button.attr("title", tooltip);
				if (link != null)
					$button.attr("link", link);
				if (commandFunc != null)
					$button.click(function(){
						if(!this.getAttribute('disabled'))
							commandFunc($button);
					});
				return $button;
			});
		}
	}
	$.fn.logo = function( method ) {
		if ( methods[method] ) {
			return methods[ method ].apply( this, Array.prototype.slice.call( arguments, 1 ));
		} else if ( typeof method === 'object' || typeof method === 'string' || ! method ) {
			return methods.show.apply( this, arguments );
		} 
	};  
})( jQ );