function addOption (oListbox, text, value, isDefaultSelected, isSelected) {
	var oOption = document.createElement("option");
	oOption.appendChild(document.createTextNode(text));
	oOption.setAttribute("value", value);
	if (isDefaultSelected)
		oOption.defaultSelected = true;
	else if (isSelected)
		oOption.selected = true;
	oListbox.appendChild(oOption);
}
function getChildsData($node) {
	var str = "";
	$children = $node.children();
	if ($children.length <= 0)
		return "";
	$$.each($children, function(i, child) {
		var $child = $$(child);
		if ($child.attr("type") == "6") {
			str += $child.attr("name") + "|" + $child.attr("id") + "\n";
		}
		//str += getChildsData($child);
	});
	return str;
}
function refreshCitiesList(text, countryIndex, cityIndex) {
	var xmlDoc= $$.parseXML(text);
	var $xml = $$(xmlDoc);
	var $regions = $xml.find("region");
	
	var countries = document.getElementById("rubar-weather-settings-country");
	var id = countries.options[countries.selectedIndex].value;
	var str = "";
	$$.each($regions, function(i, region) {
		var $region = $$(region);
		if ($region.attr("id") == id) {
			str = getChildsData($region, "");
			return false;
		}
	});
	var $cities = $$("#rubar-weather-settings-city");
	$cities.children().remove();
	var cities = (str).split('\n').sort();
	for (var i = 1; i < cities.length; i++)  {
		var str = cities[i].split("|");
		var selected = (countryIndex != "" && cityIndex != "" && str[1] == cityIndex);
		var $option = $$('<option></option>');
		$option.val(str[1]).html(str[0]);
		if (selected)
			$option.attr('selected', 'selected');
		$cities.append(
			$option
		);
	}
}
(function( $$ ) {
	$$.widget( "ui.weather", {
		options: {
			appendTo: document.documentElement,
			//appendTo: document.body,
			position: {
				my: "left top",
				at: "left bottom",
				collision: "true"
			}
		},
		_create: function() {
			var widget = this;
			var self = this.element;
			var index = this.options.index;
			var buttonDown = this.options.buttonDown;
			var button = this.options.button;
			var label = this.options.label;
			var guid = this.options.guid;
			/*this.button = self.options.toolbar.newButton({
				widget: 'weather',
				id: self.options.index
			}, self.options.config, function(){
				self.click();
			}, self.options.index);
			this.update();*/
			buttonDown.click(function(){
				if ( widget.menu.is(":visible") ) {
					$$(".tbui-menu").hide();
					widget.close();
				} else {
					widget.open();
				}
			});

			var $weatherSettings = $$("#weather-settings");
			if (!$weatherSettings.val()) {
				$weatherSettings = $$("<div />")
					.attr("id", "weather-settings")
					.attr("title","Настройки погоды")
					.css({
						textAlign: 'left'
					})
					.append($$("<label class='rubar-weather-settings-label' for='rubar-weather-settings-country'>Выберите страну</label><br>\
	<select class='rubar-weather-settings-input' id='rubar-weather-settings-country'/><br>\
	<label class='rubar-weather-settings-label'>Выберите город</label><br>\
	<select class='rubar-weather-settings-input' id='rubar-weather-settings-city'/><br>\
	<br><label class='rubar-rss-settings-label'>Время обновления (в часах)</label>\
	<input type='text' minValue='1' maxValue='24' maxlength='2' class='rubar-rss-settings-input' id='rubar-weather-settings-refresh' style='width:50px'>")
					)
					.appendTo( $$( this.options.appendTo || "body" )[0] )
					.dialog({
						autoOpen:	false,
						width:		320,
						draggable:	false,
						resizable:	false,
						modal:		false,
						disabled:	false,
						buttons: {
							"OK": function() {
								function checkIntPref(name) {
									var val = parseInt($$('#rubar-weather-settings-' + name).val());
									var min = parseInt($$('#rubar-weather-settings-' + name).attr('minValue'));
									var max = parseInt($$('#rubar-weather-settings-' + name).attr('maxValue'));
									if (isNaN(val) || val < min) {
										$$('#rubar-weather-settings-' + name).val(min);
										return false;
									}
									if (val > max) {
										$$('#rubar-weather-settings-' + name).val(max);
										return false;
									}
									return true;
								}						
								if (!checkIntPref('refresh'))
									return;
								
								rubar.Pref.write('weather.refresh', parseInt($$('#rubar-weather-settings-refresh').val()));
								
								var countries = document.getElementById("rubar-weather-settings-country");
								var selectedIndex = countries.selectedIndex;
								var opt = countries.options;
								var countryId = opt[selectedIndex].value;
								rubar.Pref.write('weather.countryIndex', countryId);
								
								var cities = document.getElementById("rubar-weather-settings-city");
								var selectedIndex = cities.selectedIndex;
								var opt = cities.options;
								var cityId = opt[selectedIndex].value;
								rubar.Pref.write('weather.cityIndex', cityId);									
								
								$$(this).dialog("close");
								widget.onRequest();
							}, 
							"Отмена": function() { 
								$$(this).dialog("close"); 
							} 
						}
					});
			}
			this.menu = $$( "<ul />" )
				.appendTo( $$( this.options.appendTo || "body" )[0] )
				.addClass( "tbui-corner-bottom" )
				.attr("id", "rubar-weather-menu" + index)
				.css({top: 0, left: 0, position: 'fixed' })
				.zIndex("999990 !important" )
				.hide();
			
			this.items = [];
			this.items.push({
				label: "Настройки получения погоды",
				hint: "Настройки получения погоды",
				link: "",
				callback: function(){
					var $cities = $$("#rubar-weather-settings-city");
					if ($cities.length > 0 && $cities.children().length <= 0) {
						loadTextContent('data/packages/' + guid + '/geobase.xml', 'weather' + index, function(text){
							var parser = new window.DOMParser();
							var dom = parser.parseFromString(text, "text/xml");
							var node = dom.getElementsByTagName("region");
							var str = "";
							for(var i = 0; i < node.length; i++) {
								if(node[i].getAttribute("type") == "3")
									str += node[i].getAttribute("name") + "|" + node[i].getAttribute("id") + "\n";
							}
							var countries = (str).split('\n').sort();
							
							var menuCountries = document.getElementById("rubar-weather-settings-country");
							menuCountries.addEventListener('change', function() {
								refreshCitiesList(text);
							}, false);

							var countryIndex = rubar.Pref.read('weather.countryIndex');
							var cityIndex = rubar.Pref.read('weather.cityIndex');
							for (var i = 1; i < countries.length; i++) {
								var str = countries[i].split("|");
								addOption(menuCountries, str[0], str[1], false, (countryIndex == str[1]));
							}
							refreshCitiesList(text, countryIndex, cityIndex);
						});
					}
					//$.StatLogger.LOG_USAGE("rss");
					$$('#rubar-weather-settings-refresh').val(rubar.Pref.read('weather.refresh'));
					$$('#weather-settings').dialog('open');
					return true;
				}
			});
			this._renderMenu( this.menu, this.items );
			this.menu.menu();
			function triggerCloseEvent(event) {
				if (widget.menu.is(":visible") ) {
					widget.close();
				}
			}
			$$(window).resize(triggerCloseEvent);
			//$$(window).scroll(triggerCloseEvent);
			//$$(document.body).click(triggerCloseEvent);
			$$(this.menu).click(triggerCloseEvent);
		},
		open: function ( event ) {
			$$(".tbui-menu").hide();
			this.menu.appendTo( $$( this.options.appendTo || "body" )[0] )
			this.menu.show().position( $$.extend({
				of: this.element
			}, this.options.position ));
		},
		close: function( event ) {
			if (this.menu.is(":visible") ) {
				this._trigger( "close", event );
				this.menu.hide();
			}
		},
		onRequest: function(data){
			var $buttonDown = this.options.buttonDown;
			var $button = this.options.button;
			var $label = this.options.label;
			var $infoButton = this.options.infoButton;
			var $icon = this.options.icon;
			var cityId = rubar.Pref.read('weather.cityIndex');
			var url = "http://export.yandex.ru/bar/reginfo.xml?region=" + (cityId ? cityId : "");

			rubar.toolbar.getXMLHttpRequest('GET', url, {}, function(respText) {
				var xmlDoc= $$.parseXML(respText);
				$xml = $$(xmlDoc);
				$weather = $xml.find("weather");
				$button.attr('link', $weather.find("url").text());
				var $day = $weather.find("day");
				var city = $day.find("title").text();
				var $day_part = $weather.find("day_part");
				var temperature = $day_part.find("temperature").text();
				var $url = $weather.find("url");
				$infoButton.attr('link', $url.text());
				$label.text(city + ":" +  temperature + " °C");
				if($icon) {
					$icon.css({
						'background-image': 'url("' + $day_part.find("image").text() + '")'
					});
				}
				//this.toolbarButton.setAttribute("image", $.XMLHelper.getChildNodeValue(day_part, "image"));
				$label.attr("title", city + ":" +  temperature + " °C: " + $day_part.find("weather_type").text());
			});
		},
		_renderMenu: function( ul, items ) {
			var self = this;
			$$.each( items, function( index, item ) {
				self._renderItem( ul, item );
			});
		},
		_renderItem: function( ul, item) {
			var $li = $$( "<li />" )
				.data( "item.menu", item )
				.append( $$( "<a />" )						
					.text( item.label )
					.attr("title", item.hint) )
				.appendTo( ul );
				if (item.link != "")
					$li.click(function(){
						rubar.browser.openUILink(item.link, true);
					});
				else if(item.callback)
					$li.click(function(){
						item.callback();
					});
			return $li;
		},
		click: function(){
			//window.location.href = $("link", this.options.config).text();
		}
	});
})( jQ );