(function( $$ ) {
	$$.widget( "ui.combobox", {
		_create: function() {
			var self = this,
				select = this.element.hide(),
				selected = select.children( ":selected" ),
				value = selected.val() ? selected.text() : "";
			var input = $$( "<input>" )
				.insertAfter( select )
				.attr( "name", select.attr("name"))
				.val( value )
				.keypress(function(aEvent){
					if (aEvent.which == '13') {
						doCommand(select.attr("id"), select.attr("command"));
					}
				})
				.addClass( "tbui-widget tbui-widget-content tbui-corner-left" );

			$$( "<button>&nbsp;</button>" )
				.attr( "tabIndex", -1 )
				.attr( "title", "Show All Items" )
				.insertAfter( input )
				.button({
					icons: {
						primary: "tbui-icon-triangle-1-s"
					},
					text: false
				})
				.removeClass( "tbui-corner-all" )
				.addClass( "tbui-corner-right tbui-button-icon" )
				.click(function() {
					// close if already visible
					if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
						input.autocomplete( "close" );
						return;
					}

					// pass empty string as value to search for, displaying all results
					input.autocomplete( "search", "" );
					input.focus();
				});
			function triggerCloseEvent() {
				if ( input.autocomplete( "widget" ).is(":visible") ) {
						input.autocomplete( "close" );
				}
			}
			
			$$(window).resize(triggerCloseEvent);
			$$(window).scroll(triggerCloseEvent);
			//$$(document.body).click(triggerCloseEvent);						
		}
	});
})( jQ );