(function( $$ ) {
	function newMailDropDownButton(param) {
		var index = param.index;
		var link = param.link;
		var caption = param.caption;
		var icon = param.icon;
		var guid = param.guid;
		if ($$("#rubar-dropdown-button" + index).length > 0) {
			$dropDownButton = $$("#rubar-dropdown-button" + index);
			$button = $$("#rubar-button" + index);
			$label = $$("#rubar-button-caption" + index);
			$buttonDown = $$("#rubar-buttonDown" + index);
		} else {
			var $dropDownButton = $$("<div />")
				.attr("id", "rubar-dropdown-button" + index)
				.addClass('rubar-button')
				.appendTo('#RubarToolbar')
			var $button = $$("<div />")
				.css({
					"height":	"24px",
					"float":	"left",
					"padding":"0px",
				})
				.attr('id', 'rubar-button' + index)
				.appendTo($dropDownButton);
			if (link) {
				$button.attr('link', link)
				$button.click(function() {
					var url = $$(this).attr('link');
					rubar.browser.openUILink(url);
				})
			}
			var $icon = null;
			$icon = $$('<div />')
				.attr("id", "rubar-button-icon" + index)
				.addClass('rubar-button-icon')
				.appendTo("#rubar-button" + index);
			if (icon != '') {
				loadBinContent("rubar-button-icon" + index, 'data/packages/' + guid + '/' + icon);
			}
			$label = $$('<p />')
				.text(caption)
				.attr('id', 'rubar-button-caption' + index)
				.addClass('rubar-button-caption')
				.appendTo("#rubar-button" + index);
			var $buttonDown = $$("<div />")
				.css({
					"height":	"24px",
					"border-left": "1px solid #dce1ee",
					"float":	"left",
					"padding":	"0px",
				})
				.attr('id', 'rubar-buttonDown' + index)
				.append($$('<div />')
					.attr("id", "rubar-button-down-icon" + index)
					.addClass('rubar-button-icon-empty')
					.addClass('rubar-button-icon-down')						
				)
				.appendTo($dropDownButton);
		}
		return {
			$button: $dropDownButton,
			children: {
				$button: $button,
				$label: $label,
				$buttonDown: (link) ? $buttonDown: $dropDownButton,
				$icon: $icon
			}
		}
	}
	var button, domain, menu, widgetData;
	$$.widget( "ui.mailchecker", {
		_create: function() {
			var self = this;
			this.toolbar = this.options.toolbar;
			this.config = this.options.config;
			//button = self.toolbar.newMenuButton(self.options.config, self.options.index);
			var icon = decodeURIComponent($$(self.options.config).find('icon:first').text());
			var caption = decodeURIComponent($$(self.options.config).find('caption').text());
			var guid = $$(self.options.config).find('guid').text();
			var menuItems = $$(self.options.config).find('menuitems');
			var dropDownButton = newMailDropDownButton({
				index: this.options.index,
				link: null,
				caption: caption ? caption : 'Почта',
				icon: icon ? icon : 'images/icon_mail.png',
				guid: guid
			});
			dropDownButton.$button.popupMenu({
				menu: menuItems,
				index: this.options.index,
				buttonDown: dropDownButton.children.$buttonDown,
				guid: guid
			});
			button = dropDownButton.$button;
			
			this.update();
			menu = $$("#rubar-menu" + this.options.index);
			
			this.addMenuItem('append', 'Настройки', function(){
				self.settings();
			});
		},
		onRequest: function(data){
			widgetData = data;
			console.log('________________________________________________MAIL XML HAS BEEN UPDATED_________________________________________________________________________________\n\n'+JSON.stringify(data));
			this.updateXml(data.mail);
		},
		addMenuItem: function(appendType, label, callback){
			menu[appendType](
				$$( "<li />" ).addClass('tbui-menu-item').attr('role', "menuitem").append(
					$$('<a style="height: 24px" tabindex="-1" id="tbui-active-menuitem" />').attr('title', label).append(
						$$('<div id="rubar-popupmenu-button-icon1_1" class="rubar-button-icon"/>')
					).append(
						$$('<p class="rubar-button-caption"></p>').text(label)
					).append(
						$$('<div class="rubar-button-icon-empty"/>')
					).hover(function(){
						$$(this).addClass('tbui-state-hover');
					}, function(){
						$$(this).removeClass('tbui-state-hover');
					})
				).click(callback)
			).popupMenu('_renderMenu');
		},
		update: function(force){
			force = (typeof force == 'undefined' || !force)?false:true;
			var self = this;
			this.toolbar.widgetRequest('MailChecker', {force: force}, function(data){
				console.log(JSON.stringify(data.mail))
				if (data.mail.yandex.count<0 && window.location.href.indexOf('http://mail.yandex.ru/neo2/')>=0){
					self.update(true)
				} else if (data.mail.gmail.count<0 && window.location.href.indexOf('https://mail.google.com/mail/u')>=0){
					self.update(true)
				} else if (data.mail.mail.count<0 && window.location.href.indexOf('mail.ru/')>=0){
					self.update(true)
				}
				widgetData = data;
				self.updateXml(data.mail);
			});
		},
		enable: function(){
			button.removeAttr("disabled");
		},
		updateXml: function( data){
			//console.log('_______________________________________________________________________________\n' + data.yandex+"\n\n\n"+$$("li > a > p", menu).eq(0));
			var buttonText = (data.yandex.count>=0)?data.yandex.count:((data.gmail.count>=0)?data.gmail.count:((data.mail.count>=0)?data.mail.count: null));
			if(buttonText)
				button.find("p").text("Почта (" + buttonText + ")");
			$$("li > a > p", menu).eq(0).empty().append( (data.yandex.count>=0)? ("<b>" + data.yandex.name + "</b>: " + data.yandex.count) : "Яндекс.Почта: Войти" );
			$$("li > a > p", menu).eq(1).empty().append( (data.gmail.count>=0) ? ("<b>" + data.gmail.name + "</b>: " + data.gmail.count)   : "Gmail: Войти" );
			$$("li > a > p", menu).eq(2).empty().append( (data.mail.count>=0)  ? ("<b>" + data.mail.name + "</b>: " + data.mail.count)     : "Mail.ru: Войти" );
			
			
		},
		settings: function() {
			//alert('settings')
			var self = this;
			$$("<div />").append(
				$$("<table />").append(
					$$("<tr />").append(
						$$("<td colspan=2 />").append(
							$$("<input type='checkbox' style='margin:5px;'>")
								.attr('id', 'RubarMailchekerAuto')
								.setChecked(widgetData && widgetData.auto)
						).append(
							$$("<label />").text("Автоматически проверять почту")
						)
					)
				).append(
					$$("<tr />").append(
						$$("<td />").text("Интервал проверки, мин.")
					).append(
						$$("<td />").append(
							$$("<input />")
								.attr("type", "text")
								.attr('id', 'RubarMailchekerInterval')
								.css({'width': '30px'}).val(widgetData.interval)
						)
					)
				)
			).dialog({
				title: 'Настройки',
				resizable: false,
				draggable: false,
				buttons: {
					'Ok': function(){
						if(($('#RubarMailchekerInterval').val() == parseInt($('#RubarMailchekerInterval').val())) && parseInt($$('#RubarMailchekerInterval').val())>0){
							self.toolbar.widgetRequest('MailChecker', {
								interval: parseInt($('#RubarMailchekerInterval').val()),
								auto: $$('#RubarMailchekerAuto').is(':checked')
							}, function(data){
								widgetData = data;
								self.updateXml(data.mail);
							});
							$$(this).dialog("close"); 
						} else {
							alert('Некорректный интервал');
						}
					},
					'Отмена': function(){
						$$(this).dialog("close"); 
					}
				}
			});
		}
		
	});
})( jQ );