(function( $$ ) {
	var index, guid;
	$$.widget( "ui.popupMenu", {
		
		options: {
			appendTo: document.documentElement,
			//appendTo: document.body,
			position: {
				my: "left top",
				at: "left bottom",
				collision: "true"
			}
		},
		reload: function() {
			var menu = this.options.menu;
			$$("#rubar-menu" + this.index).children().remove();
			this.menu = $$("#rubar-menu" + this.index);
			this.items = $$(menu).children("item").map(function(i, item){
				return {
					label: $$(this).attr('text'),
					hint: $$(this).attr('text'),
					link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
					icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
					submenu: $$(this).children('item') ? $$(this).children('item') : null
				}
			});
			this._renderMenu( this.menu, this.items );
			this.menu.menu('refresh');
		},
		_create: function() {
			var widget = this;
			var self = this.element;
			var menu = this.options.menu;
			guid = this.options.guid;
			this.index = this.options.index;
			var buttonDown = this.options.buttonDown;
			this.level = 1;
			
			if ($$('#rubar-menu' + index).length == 0) {
				buttonDown.click(function(){
					if ( widget.menu.is(":visible") ) {
						$$(".tbui-menu").hide();
						//$$("ul[level=2]").hide();
						widget.close();
					} else {
						widget.open();
					}
				});
				
				this.menu = $$( "<ul />" )
					.appendTo( $$( this.options.appendTo || "body" )[0] )
					.attr('level', this.level)
					.css({top: 0, left: 0, position: 'fixed' })
					.zIndex("999990 !important" )
					.attr('id', 'rubar-menu' + this.index)
					.hide();
				this.items = $$(menu).children("item").map(function(i, item){
					return {
						label: $$(this).attr('text'),
						hint: $$(this).attr('text'),
						link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
						icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
						submenu: $$(this).children('item') ? $$(this).children('item') : null
					}
				});
				this._renderMenu( this.menu, this.items );
				this.menu.menu();
			} else {
				$$("#rubar-menu" + this.index).children().remove();
				this.menu = $$("#rubar-menu" + this.index);
				this.items = $$(menu).children("item").map(function(i, item){
					return {
						label: $$(this).attr('text'),
						hint: $$(this).attr('text'),
						link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
						icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
						submenu: $$(this).children('item') ? $$(this).children('item') : null
					}
				});
				this._renderMenu( this.menu, this.items );
				this.menu.menu('refresh');
			}

			function triggerCloseEvent(event) {
				if (widget.menu.is(":visible") ) {
					widget.close();
					event.originalEvent.preventDefault();
				}
			}
			
			$$(window).resize(triggerCloseEvent);
			//$$(window).scroll(triggerCloseEvent);
			$$(document.body).click(triggerCloseEvent);
			$$(this.menu).click(triggerCloseEvent);
		},
		open: function ( event ) {
			$$(".tbui-menu").hide();
			this.menu.appendTo( $$( this.options.appendTo || "body" )[0] )
			this.menu.show().position( $$.extend({
				of: this.element
			}, this.options.position ));
		},
		close: function( event ) {
			if ( this.menu.is(":visible") ) {
				this._trigger( "close", event );
				this.menu.hide();
			}
		},
		_renderMenu: function( ul, items ) {
			var self = this;
			$$.each( items, function( index, item ) {
				self._renderItem( ul, item, index );
			});
		},

		_renderItem: function( ul, item, index) {
			var buttonIconId = "rubar-popupmenu-button-icon" + this.level + "_" + index;
			var $li = $$( "<li />" )
				.data( "item.menu", item )
				.appendTo( ul );
			if (item.label == ''){
					$li.addClass('tbui-menu-item-separator')
			} else {
				var $a = $$( "<a />" )
					.append( $$( "<div />" )
						.attr("id", buttonIconId)
						.addClass('rubar-menu-item-icon')
					)
					.append($$('<p />')
						.text( item.label)
						.addClass('rubar-button-caption')
					)
					.attr("title", item.hint)
					.css({height:'24px'})
					.appendTo( $li );
					
				var $button = $$('<div />')
					.addClass('rubar-button-icon-empty')
					.appendTo($a);
				if (item.icon != '') {
					loadBinContent(buttonIconId, 'data/packages/' + guid + '/' + item.icon);
				}
				if (item.link != '') {
					$li.click(function() {
						//alert(item.link);
						rubar.browser.openUILink(item.link);
					});
				}
				if (item.submenu.length > 0) {
					$button.addClass('rubar-button-icon-right');
					var $subMenu = $li.popupSubMenu({
						menu: item.submenu,
						level: this.level + 1,
						index: 1,
						guid: guid
					});
				}
				$li.hover(function() {
					$$("ul[level=2]").hide();
					if (item.submenu.length > 0) {
						$subMenu.popupSubMenu('open');
					}
				},
				function() {
				});
			}
			return $li;
		}
	});
})( jQ );

(function( $$ ) {
	var guid;
	var itemIndex = 0;
	$$.widget( "ui.popupSubMenu", {
		options: {
			appendTo: document.documentElement,
			//appendTo: document.body,
			position: {
				my: "left top",
				at: "right top",
				collision: "true"
			}
		},
		_create: function() {
			var widget = this;
			var self = this.element;
			var menu = this.options.menu;
			var index = this.options.index;
			this.level = this.options.level;
			guid = this.options.guid;
			this.menu = $$( "<ul />" )
				.appendTo( $$( this.options.appendTo || "body" )[0] )
				.attr('level', this.level)
				.css({top: 0, left: 0, position: 'fixed' })
				.zIndex("999990 !important" )
				.hide();
					
			var theMenu = this.menu;
			theMenu.hover(
				function(){},
				function(){
					theMenu.hide();
				});
			
			this.items = menu.map(function(i, item){
				return {
					label: $$(this).attr('text'),
					hint: $$(this).attr('text'),
					link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
					icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
					submenu: $$(this).children('item') ? $$(this).children('item') : null
				}
			});
			this._renderMenu( this.menu, this.items );
			this.menu.menu();
			
			function triggerCloseEvent(event) {
				if (widget.menu.is(":visible") ) {
					widget.close();
				}
			}
			
			$$(window).resize(triggerCloseEvent);
			//$$(window).scroll(triggerCloseEvent);
			//$$(document.body).click(triggerCloseEvent);
			$$(this.menu).click(triggerCloseEvent);
		},
		open: function ( event ) {
			//$$(".tbui-menu").hide();
			this.menu.appendTo( $$( this.options.appendTo || "body" )[0] )
			this.menu.show().position( $$.extend({
				of: this.element
			}, this.options.position ));
		},
		close: function( event ) {
			if ( this.menu.is(":visible") ) {
				this._trigger( "close", event );
				this.menu.hide();
			}
		},
		_renderMenu: function( ul, items ) {
			var self = this;
			$$.each( items, function( index, item ) {
				self._renderItem( ul, item, index );
			});
		},

		_renderItem: function( ul, item, index) {
			itemIndex++;
			var buttonIconId = "rubar-popupmenu-button-icon" + this.level + "_" + itemIndex;
			var $li = $$( "<li />" )
				.data( "item.menu", item )					
				.appendTo( ul );
				
			var $a = $$( "<a />" )
				.append( $$( "<div />" )
					.attr("id", buttonIconId)
					.addClass('rubar-menu-item-icon')
				)
				.append($$('<p />')
					.text( item.label)
					.addClass('rubar-button-caption')
				)
				.attr("title", item.hint)
				.css({height:'24px'})
				.appendTo( $li );
				
			var $button = $$('<div />')
				.addClass('rubar-button-icon-empty')
				.appendTo($a);
			if (item.icon != '') {
				loadBinContent(buttonIconId, 'data/packages/' + guid + '/' + item.icon);
			}
			if (item.link != '') {
				$li.click(function() {
					rubar.browser.openUILink(item.link);
				});
			} else {
				if (item.submenu) {
					$li.addClass('rubar-button-icon-right');
				}
			}
			return $li;
				//.click(function(){doCommand( item.id, item.command)});
		}
	});
})( jQ );