﻿// ==UserScript==
// @name        inject
//
// @include     http://*
// @include     https://*

// ==/UserScript==
var rubar = null;
function Rubar() {
	var self = this;

	this.Pref = {
		write : function (pref, value) {
			widget.preferences[pref] = value;
		},
		read : function (pref) {
			return widget.preferences[pref];
		}
	};

	this.log = function(arg) {
		//console.log(arg);
	};

    this.fnCallbacks = {};

	this.rssButton = {};

	this.browser = {
		openUILink: function(url, newtab) {
			var newtab = newtab ? newtab : false;
			opera.extension.postMessage({
				action:'rubar_browser_navigate',
				url: unescape(url),
				newtab: newtab
			});
		}
	};

	this.toolbar = {
		getXMLHttpRequest : function (method, url, data, fnCallback) {
			opera.extension.postMessage({
				action: 'ruBar_xmlHttpRequest',
				url:	url,
				mehod: method,
				data: 	data
			});
			self.fnCallbacks['ruBar_xmlHttpRequest_' + url] = fnCallback;
		},

		widgetRequest: function(widget, data, callback, index){
			if(typeof widget == 'string'){
				widget = {
					widget: widget,
					id: index
				};
			}
			opera.extension.postMessage({
				'action': 'ruBar_widgetRequest',
				'widget':	widget.widget,
				'id':	widget.id,
				'data': data
			});
			self.fnCallbacks['ruBar_widgetRequest_' + widget.widget + widget.id] = callback;
		},

		newButtonControl: function(btnInfo, index) {
			return this.newButton(null, btnInfo, function($button) {
				self.browser.openUILink($button.attr("link"));
            }, index);
		},

		newLogo: function(btnInfo, index) {
			$('<div />').logo($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"));
            }, index);
		},

		rubarButton: function(btnInfo, index) {
			$('<div />').rubarButton($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"));
            }, index);
		},

		newHtmlControl: function(btnInfo, index) {
			var id = "RubarHtmlControl" + index;
			var caption = $$(btnInfo).find('caption').text();
			var btnwidth = $$(btnInfo).find('btnwidth').text();
			var btnlink = $$(btnInfo).find('btnlink').text();
			$$('<div />')
				.attr("id", id)
				.css({
					"width": btnwidth + "px", 
					"height":"30px",
					"margin":"0px",
					"border": "1px solid #eee",
					"float": "left",
					"padding":"1px"					
				})
				.addClass('rubar-button')
				.appendTo('#RubarToolbar');
			if (btnlink != '')
				loadTextContent('data/' + btnlink, id, function(text){
					$$('#' + id).html(text);
				});
		},

		newHtmlButton: function(btnInfo, index) {
			$('<div />').newHtmlButton($$(btnInfo), null, index);
		},

		newSearchControl: function(btnInfo, index) {
			var link = decodeURIComponent($$(btnInfo).find('link').text());
			var icon = $$(btnInfo).find('icon').text();
			var caption = $$(btnInfo).find('caption').text();
			var tooltip = $$(btnInfo).find('tooltip').text();
			var guid = $$(btnInfo).find('guid').text();
			var id = "rubar-searchcontrol" + index;
			var idInput = "rubar-searchcontrol-input" + index;
			var idButton = "rubar-searchcontrol-button" + index;
			var $div = $$("<div />")
				.css({
					"width":"auto !important",
					"height":	"28px",
					"margin":	"0px",
					"border": 	"0px",
					"float":	"left",
					"padding":	"0px"
				})
				.attr("id", id)
				.appendTo('#RubarToolbar')
			var $input = $$( "<input />" )
				.appendTo( $div )
				.attr("id", idInput)
				.addClass("rubar-search-input")
				.attr( "name", "name");
			
			var $button = $$( "<div />" )
				.appendTo( $div )
				.attr("id", idButton)
				.addClass('rubar-button');
				
			// image
			if (icon != '') {	
				$$('<div />')
					.attr("id", idButton + "_icon")
					.addClass('rubar-button-icon')
					.appendTo($button);
				loadBinContent(idButton + "_icon", 'data/packages/' + guid + '/' + icon);
			}
			if (caption != '') {
				$$('<p />')
					.text(caption)
					.addClass('rubar-button-caption')
					.appendTo($button);
			}
			if (tooltip != '')
				$button.attr('title', tooltip);

			if (link != null)
				$button.attr("link", link);
				
			$button.click(function(){
				var text = $$("#" + idInput).attr('value');
				if (text == "")
					return;
				var link = $$(this).attr('link');
				//link = link.replace("{MYSEARCHTERM}", text + "&clid=" + $.Settings.clids["clid0"]);
				link = link.replace("{MYSEARCHTERM}", text + "&clid=128857");
				self.browser.openUILink(link);
				//$.StatLogger.LOG_USAGE("search&clid=" + $.Settings.clids["clid0"]);
				
			});
			$input.keypress(function(aEvent) {
				if (aEvent.which == '13') {
					$button.click();
				}
			});
			$input.autocomplete({
				source: function( request, response ) {
					var url = "http://suggest.yandex.ru/suggest-ya.cgi?ct=text/html&part=" + encodeURIComponent(request.term);
					rubar.toolbar.getXMLHttpRequest('GET', url, {}, function(respText) {
						var istart = respText.indexOf("[", respText.indexOf("[") + 1);
						var parsed = respText.substr(istart, respText.indexOf("]", istart) - istart + 1); 
						response(JSON.parse(parsed));
					});
				},
				select: function(event, ui) {
					$button.click();
				},
				minLength: 2
			});
			$input.click(function(e) {
				//$.StatLogger.LOG_STAT("stat", "search_field_click"); 
			});
			var input = $input.get(0);
			window.addEventListener("mouseup", function(e) {
				if(e.target == input)
					return;
				var selText = window.getSelection().toString();
				if (input.value != selText && selText.length )
				   input.value = selText;
			}, false);
			return $div;
		},

		newHtmlPopup: function(btnInfo, index) {
			//
		},

		newWeatherButton: function(btnInfo, index) {
			var script = $$(btnInfo).find('script') ? $$(btnInfo).find('script').text(): null;
			var link = $$(btnInfo).find('link') ? $$(btnInfo).find('link').text(): null;
			var icon = $$(btnInfo).find('icon').text();
			var caption = $$(btnInfo).find('caption').text();
			var tooltip = $$(btnInfo).find('tooltip').text();
			var guid = $$(btnInfo).find('guid').text();
			if (script) {
				eval(script);
			}
			var dropDownButton = this.newDropDownButton({
				index: index,
				link: link,
				caption: caption,
				icon: icon,
				guid: guid,
                iconClass: 'rubar-weather-icon'
			});

            dropDownButton.$button.weather({
				index: 		index,
				button:		dropDownButton.$button,
				infoButton:	dropDownButton.children.$button,
				buttonDown:	dropDownButton.children.$buttonDown,
				label: 		dropDownButton.children.$label,
				icon:		dropDownButton.children.$icon,
				guid:		guid
			});
			var refresh = parseInt(rubar.Pref.read('weather.refresh'));
			refresh = (refresh > 1) ? refresh : 1;
			refresh = (refresh < 24) ? refresh: 24;
			opera.extension.postMessage({
				action: 'ruBar_setInterval',
				name:	"rubar-weather" + index,
				interval: 1000 * 60 * 24 * refresh
			});
			self.fnCallbacks['ruBar_setInterval_' + "rubar-weather" + index] = function() {
				dropDownButton.$button.weather('onRequest');
			};
			dropDownButton.$button.weather('onRequest');
		},

		newRadioButton: function(btnInfo, index) {
			//
		},

		newRSSButton: function(btnInfo, index) {
			// Parse main RSS channel data
			var link = $$(btnInfo).find('link') ? $$(btnInfo).find('link').text(): null;
			var icon = $$(btnInfo).find('icon').text();
			var guid = $$(btnInfo).find('guid').text();
			var dropDownButton = this.newDropDownButton({
				index: index,
				link: link,
				caption: "",
				icon: icon,
				guid: guid
			});

			dropDownButton.$button.menuRss({
				index: index,
				buttonDown: dropDownButton.children.$buttonDown
			});

			function RequestRSS() {
				rubar.toolbar.getXMLHttpRequest('GET', unescape(link), {}, function(respText) {
					var parser = new window.DOMParser();
					var xml = parser.parseFromString(respText, "text/xml");
					var channel = xml.getElementsByTagName("channel")[0];
					dropDownButton.$button.attr('link', $$(channel).children("link").text());
					dropDownButton.children.$label.text($$(channel).children("title").text());
					dropDownButton.$button.menuRss('loadChannel', channel);
				});
			}

			rubar.Pref.write("lastRSSIndex", "0");
			opera.extension.postMessage({
				action: 'ruBar_setInterval',
				name:	"rubar-rss" + index,
				interval: parseInt(rubar.Pref.read('rss.refresh')) * 1000 * 60
			});
			self.fnCallbacks['ruBar_setInterval_' + "rubar-rss" + index] = RequestRSS;

			RequestRSS();
		},

		newMultiRSSButton: function(btnInfo, index) {
			//
		},

		newDropDownButton: function(param) {
			var index = param.index;
			var link = param.link;
			var caption = param.caption;
			var icon = param.icon;
			var guid = param.guid;

            var iconClass = param.iconClass || 'rubar-button-icon';

			if ($$("#rubar-dropdown-button" + index).length > 0) {
				$dropDownButton = $$("#rubar-dropdown-button" + index);
				$button = $$("#rubar-button" + index);
				$label = $$("#rubar-button-caption" + index);
				$buttonDown = $$("#rubar-buttonDown" + index);
			} else {
				var $dropDownButton = $$("<div />")
					.attr("id", "rubar-dropdown-button" + index)
					.addClass('rubar-button')
					.appendTo('#RubarToolbar')
				var $button = $$("<div />")
					.css({
						"height":	"24px",
						"float":	"left",
						"padding":"0px"
					})
					.attr('id', 'rubar-button' + index)
					.appendTo($dropDownButton);
				if (link) {
					$button.attr('link', link)
					$button.click(function() {
						var url = $$(this).attr('link');
						rubar.browser.openUILink(url);
					})
				}
				var $icon = null;
				$icon = $$('<div />')
					.attr("id", "rubar-button-icon" + index)
					.addClass( iconClass )
					.appendTo("#rubar-button" + index);
				if (icon != '') {	
					loadBinContent("rubar-button-icon" + index, 'data/packages/' + guid + '/' + icon);
				}
				$label = $$('<p />')
					.text(caption)
					.attr('id', 'rubar-button-caption' + index)
					.addClass('rubar-button-caption')
					.appendTo("#rubar-button" + index);

				var $buttonDown = $$("<div />")
					.css({
						"height":	"24px",
						"border-left": "1px solid #dce1ee",
						"float":	"left",
						"padding":	"0px"
					})
					.attr('id', 'rubar-buttonDown' + index)
					.append($$('<div />')
						.attr("id", "rubar-button-down-icon" + index)
						.addClass('rubar-button-icon-empty')
						.addClass('rubar-button-icon-down')						
					)
					.appendTo($dropDownButton);
				}

			return {
				$button: $dropDownButton,
				children: {
					$button: $button,
					$label: $label,
					$buttonDown: (link) ? $buttonDown: $dropDownButton,
					$icon: $icon
				}
			};
		},

		newMenuButton: function(btnInfo, index) {
			var link = $$(btnInfo).find('link')? decodeURIComponent($$(btnInfo).find('link').text()): null;
			var icon = decodeURIComponent($$(btnInfo).find('icon').text());
			var caption = decodeURIComponent($$(btnInfo).find('caption').text());
			var guid = $$(btnInfo).find('guid').text();
			var menu = $$(btnInfo).find('menuitems');
			var dropDownButton = this.newDropDownButton({
				index: index,
				link: link,
				caption: caption,
				icon: icon,
				guid: guid
			});
			dropDownButton.$button.popupMenu({
				menu: menu,
				index: index,
				buttonDown: dropDownButton.children.$buttonDown,
				guid: guid
			});
			//dropDownButton.$button.popupMenu('reload', menu);
			return dropDownButton.$button;
		},

		newButton: function(id, btnInfo, commandFunc, index)  {
			var link = decodeURIComponent($$(btnInfo).find('link:first').text());
			var icon = $$(btnInfo).find('icon:first').text();
			var caption = $$(btnInfo).find('caption:first').text();
			var tooltip = $$(btnInfo).find('tooltip:first').text();
			var guid = $$(btnInfo).find('guid').text();
			var id = "RubarControl" + index;
			var $button = $$('<div />')
				.attr("id", id)
				.addClass('rubar-button')
				.appendTo('#RubarToolbar');				

            if (id != null)
            {
				$button.attr("id", id);
            }

			// image
			if (icon != '') {	
				$$('<div />')
					.attr("id", id + "_icon")
					.addClass('rubar-button-icon')
					.appendTo($button);
				loadBinContent(id + "_icon", 'data/packages/' + guid + '/' + icon);
			}

			if (caption != '') {
				$$('<p />')
					.text(caption)
					.addClass('rubar-button-caption')
					.appendTo($button);
			}

			if (tooltip != "")
            {
				$button.attr("title", tooltip);
            }

            if (link != null)
            {
				$button.attr("link", link);
            }

            if (commandFunc != null)
            {
				$button.click(function(){
					if(!this.getAttribute('disabled'))
						commandFunc($button);
				});
            }

			return $button;
		},

		/* Creates popup item to menu */
		newPopupMenu: function(menuId, onshow) {
			return null;
		},

		newSeparator: function(btnInfo, index) {
			$('<div />').separator($$(btnInfo), index);
		},

		newSettingsButton: function(btnInfo, index) {
			$('<div />').logo($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"), true);
            }, index);
		},

		newMail: function(btnInfo, index) {
			/*$('<div />').logo($$(btnInfo), function($button) {
				self.browser.openUILink($button.attr("link"), true);
            }, index);*/
			$$("<div />")
				.addClass("ruBar_widgetRequest_mailchecker")
				.mailchecker({
					toolbar: rubar.toolbar,
					config: btnInfo,
					index: index
				})
				.appendTo("#RubarToolbar");
		}
	};
}

// -----------------------------------------------------------------------------------------------
function loadBinContent(id, path, attr) {
	opera.extension.postMessage({
		action: 'rubar_loadBinContent',
		path: path,
        attr: attr || 'background-image',
		id: id
	});			
}

function loadTextContent(path, name, callback) {
	opera.extension.postMessage({
		action: 'rubar_loadTextContent',
		path: path,
		name: name
	});
	rubar.fnCallbacks['rubar_loadTextContent_' + name] = callback;
}

function fixBoolPref(name) {
	if (name == "false")
		return false;
	if (name == "true")
		return true;		
	return name;
}

/* ************************************************************************* */
(function() {
	if (window.top != window.self)
		return;

    rubar = new Rubar();

	var evName = '';
	var evalued = {};
	
	function showContent(data) {
	
		initPopupMenuWidget( $$ );
		
		//console.log("data = " + data);
		var xmlDoc = $$.parseXML(data);
		var xml = $$(xmlDoc);
		var $layouts = xml.find("layout");
		$$.each($layouts.children(), function(i, $item) {
			var type = $$(this).find('type').text();
			switch(type) {
				case "custombutton":
					rubar.toolbar.newButtonControl(this, i);
					break;
				case "separator":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newSeparator(this, i);
					break;
				case "settings_button":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newSettingsButton(this, i);
					break;					
				case "logo":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newLogo(this, i);
					break;
				case "button":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.rubarButton(this, i);
					break;
				case "search":
					rubar.toolbar.newSearchControl(this, i);
					break;
				case "htmlpopup":
					rubar.toolbar.newHtmlPopup(this, i);
					break;
				case "htmlbutton":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newHtmlButton(this, i);
					break;
				case "htmlcontrol":
					//evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					//rubar.toolbar.newHtmlControl(this, i);
					break;
				case "weather":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newWeatherButton(this, i);
					break;
				/*case "currency":
					rubar.toolbar.newCurrencyButton(this, i);
					break;*/					
				case "radio":
					rubar.toolbar.newRadioButton(this, i);
					break;
				case "native":
					break;
				case "mail":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newMail(this, i); 	
					break;
				case "rss":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newRSSButton(this, i); 	
					break;
				case "multirss":
					rubar.toolbar.newMultiRSSButton(this, i);
					break;
				case "menu":
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					rubar.toolbar.newMenuButton(this, i);
					break;
				default: 
					//-- Widget factory
					evalScript(type, $$(this).find('script') ? $$(this).find('script').text(): null);
					if ($$.fn[type]) {
						$$("<div />")
							.addClass("ruBar_widgetRequest_" + type)[type]({
								toolbar: rubar.toolbar,
								config: this,
								index: i
							})
							.appendTo("#RubarToolbar");
					}
					//-- End of Widget factory
			}
		});
	}

	function evalScript(type, script) {
		if (!evalued[type] && script) {
			evalued[type] = true;
			eval(script);
		}		
	}

	function showToolbarTrigger( isVisible )
    {
		if (!isVisible && $$('#RubarToolbar').length != 0)
        {
			$$("#RubarToolbarPopup").remove();
			$$('#RubarToolbar').toolbar('hide');
			removeStyle("ruBar_div_cuzadpn");
		}
        else if(isVisible && $$('#RubarToolbar').length == 0)
        {
			//setStyle("div.cuzadpn { top: 30px !important }", "ruBar_div_cuzadpn");
			$$('<div />')
				.attr("id","RubarToolbar")
				.appendTo( window.document.documentElement )
                //.appendTo( window.document.body )
				.toolbar();

            window.setTimeout(function() {
				opera.extension.postMessage({
					action: 'rubar_loadContent'
				});
			}, 500);
		}
	}

	function openPopup(options) {
		$$("#RubarToolbarPopup").remove();
		$$("<iframe />")
			.attr("id", "RubarToolbarPopup")
			.popup(options);
	}

	function closePopup() {
		$$("#RubarToolbarPopup").remove();
	}

	function ruBarRemoveEventListener(eventname) {
		document.removeEventListener(eventname, eventListener, false);
	}

	function ruBarAddEventListener(eventname) {
		evName = eventname;
		document.addEventListener(eventname, eventListener, false);
	}

	function eventListener(e) {
		opera.extension.postMessage({
			action: 'ruBar_eventListener',
			name:	evName,
			value:	'undefined'
		});
	}

	function setCookie(name, value, expiresDate) {
		var exdate = new Date(expiresDate);
		var val = escape(value) + ((expiresDate == null) ? "" : "; expires=" + exdate.toUTCString());
		var str = name + "=" + val
		document.cookie = str;
	}

	function getCookie(name) {
		var _name, val, cookies = document.cookie.split(";");
		for (var i = 0; i < cookies.length; i++) {
			_name = cookies[i].substr(0, cookies[i].indexOf("="));
			val = cookies[i].substr(cookies[i].indexOf("=") + 1);
			_name = _name.replace(/^\s+|\s+$$/g, "");
			if (_name == name) {
				return unescape(val);
			}
		}
	}

	function setStyle(css, id) {
		var s = document.createElement('style');
		s.setAttribute('id', id);
		s.setAttribute('type', 'text/css');         
		s.appendChild(document.createTextNode(css));
		document.getElementsByTagName('head')[0].appendChild(s);
	}

	function removeStyle(id) {
		$$('#' + id).remove();
	}

	// ---------------------- browser events ------------------------------
	window.addEventListener('DOMContentLoaded', function() {
		scriptLoader.fire();
		var bVisible =  (widget.preferences['visible'] != null) ? widget.preferences['visible'] : true;
		bVisible = fixBoolPref(bVisible);
		showToolbarTrigger(bVisible);
		window.setTimeout(function() {
			opera.extension.postMessage({
				action: 'LoadInjectedCSS',
				data: 'css/style.css'
			});
			opera.extension.postMessage({
				action: 'LoadInjectedCSS',
				data: 'css/jquery-ui-1.8.6.custom.css'
			});
		}, 500);
		
		opera.extension.addEventListener('message', function(event) {
		
			if (!event || !event.data || !event.data.action)
				return;
			var msg = event.data;
			switch(msg.action) {
				case 'rubar_tb_showToolbarTrigger':
					showToolbarTrigger(msg.visible);
					return;
				case 'ruBar_openPopup' :
					openPopup(msg.options);
					return;
				case 'ruBar_closePopup' :
					closePopup();
					return;
				case 'rubar_showContent':
					showContent(msg.xml);
					return;
				case 'css':
					setStyle(msg.data.css, 'RubarToolbarCustomStyleNoPrint');
					return;
				case 'rubar_loadTextContent':
					if (typeof rubar.fnCallbacks['rubar_loadTextContent_' + msg.name] != 'undefined') {
						rubar.fnCallbacks['rubar_loadTextContent_' + msg.name](msg.content);
						delete rubar.fnCallbacks['rubar_loadTextContent_' + msg.name];
					}
					return;
				case 'rubar_loadBinContent':
					switch( msg.attr )
                    {
                        case 'background-image':
                            $$('#' + msg.id).css({
                                "background-image" : "url('data:image/png;base64," + msg.content + "')"
                            });
                            break;
                        case 'src':
                            $$('#' + msg.id).attr( 'src', 'data:image/png;base64,' + msg.content );
                            break;
                    }
                    return;
				case 'ruBar_setControlWidth':
					$$('#' + msg.controlname).css({
						"width" : msg.width + "px"
					});
					return;
				case 'ruBar_setCookie':
					setCookie(msg.name, msg.value, msg.expiresDate);
					return;
				case 'ruBar_getCookie':
					opera.extension.postMessage({
						action: 'ruBar_getCookieVar',
						name: 	msg.name,
						value: 	getCookie(msg.name)
					});
					return;
				case 'ruBar_addEventListener':
					ruBarAddEventListener(msg.name);
					return;
				case 'ruBar_removeEventListener':
					ruBarRemoveEventListener(msg.name);
					return;
				case 'ruBar_xmlHttpRequest':
					if (typeof rubar.fnCallbacks['ruBar_xmlHttpRequest_' + msg.url] != 'undefined') {
						rubar.fnCallbacks['ruBar_xmlHttpRequest_' + msg.url](msg.xhr.responseText);
						delete rubar.fnCallbacks['ruBar_xmlHttpRequest_' + msg.url];
					}
					return;
				case 'ruBar_setInterval':
					console.log(msg.name)
					if (typeof rubar.fnCallbacks['ruBar_setInterval_' + msg.name] != 'undefined') {
						rubar.fnCallbacks['ruBar_setInterval_' + msg.name](msg.data);
						//delete rubar.fnCallbacks['ruBar_setInterval_' + msg.name];
					}
					return;
				case 'ruBar_widgetResponse':
					if (typeof rubar.fnCallbacks['ruBar_widgetRequest_' + msg.widget+ msg.id] != 'undefined') {
						rubar.fnCallbacks['ruBar_widgetRequest_' + msg.widget + msg.id](msg.data);
					}
					return;
				case 'ruBar_widgetRequest':
					if ($$(".ruBar_widgetRequest_" + msg.widget)) {
						$$(".ruBar_widgetRequest_" + msg.widget)[msg.widget]('onRequest', msg.data);
					}
					return;
			}
		}, false);
		
	}, false);
	

	
	opera.extension.ondisconnect = function(e) {
		showToolbarTrigger(false);
	}
})();

/* ******************************* popupMenu ************************************** */
function initPopupMenuWidget( $$ )
{
(function( $$ ) {
	var index, guid;
	$$.widget( "ui.popupMenu", {
		
		options: {
			appendTo: document.documentElement,
			//appendTo: document.body,
			position: {
				my: "left top",
				at: "left bottom",
				collision: "true"
			}
		},

		reload: function() {
			var menu = this.options.menu;
			$$("#rubar-menu" + this.index).children().remove();
			this.menu = $$("#rubar-menu" + this.index);
			this.items = $$(menu).children("item").map(function(i, item){
				return {
					label: $$(this).attr('text'),
					hint: $$(this).attr('text'),
					link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
					icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
					submenu: $$(this).children('item') ? $$(this).children('item') : null
				}
			});
			this._renderMenu( this.menu, this.items );
			this.menu.menu('refresh');
		},

		_create: function() {
			var widget = this;
			var self = this.element;
			var menu = this.options.menu;
			guid = this.options.guid;
			this.index = this.options.index;
			var buttonDown = this.options.buttonDown;
			this.level = 1;
			
			if ($$('#rubar-menu' + index).length == 0) {
				buttonDown.click(function(){
					if ( widget.menu.is(":visible") ) {
						$$(".tbui-menu").hide();
						//$$("ul[level=2]").hide();
						widget.close();
					} else {
						widget.open();
					}
				});
				
				this.menu = $$( "<ul />" )
					.appendTo( $$( this.options.appendTo || "body" )[0] )
					.attr('level', this.level)
					.css({top: 0, left: 0, position: 'fixed' })
					.zIndex("999990 !important" )
					.attr('id', 'rubar-menu' + this.index)
					.hide();
				this.items = $$(menu).children("item").map(function(i, item){
					return {
						label: $$(this).attr('text'),
						hint: $$(this).attr('text'),
						link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
						icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
						submenu: $$(this).children('item') ? $$(this).children('item') : null
					}
				});
				this._renderMenu( this.menu, this.items );
				this.menu.menu();
			} else {
				$$("#rubar-menu" + this.index).children().remove();
				this.menu = $$("#rubar-menu" + this.index);
				this.items = $$(menu).children("item").map(function(i, item){
					return {
						label: $$(this).attr('text'),
						hint: $$(this).attr('text'),
						link: $$(this).attr('link') ? decodeURIComponent($$(this).attr('link')) : '',
						icon: $$(this).attr('icon') ? $$(this).attr('icon') : '',
						submenu: $$(this).children('item') ? $$(this).children('item') : null
					}
				});
				this._renderMenu( this.menu, this.items );
				this.menu.menu('refresh');
			}

			function triggerCloseEvent(event) {
				if (widget.menu.is(":visible") ) {
					widget.close();
					event.originalEvent.preventDefault();
				}
			}
			
			$$(window).resize(triggerCloseEvent);
			//$$(window).scroll(triggerCloseEvent);
			$$(document.body).click(triggerCloseEvent);
			$$(this.menu).click(triggerCloseEvent);
		},

		open: function ( event ) {
			$$(".tbui-menu").hide();
			this.menu.appendTo( $$( this.options.appendTo || "body" )[0] )
			this.menu.show().position( $$.extend({
				of: this.element
			}, this.options.position ));
		},

		close: function( event ) {
			if ( this.menu.is(":visible") ) {
				this._trigger( "close", event );
				this.menu.hide();
			}
		},

		_renderMenu: function( ul, items ) {
			var self = this;
			$$.each( items, function( index, item ) {
				self._renderItem( ul, item, index );
			});
		},

		_renderItem: function( ul, item, index) {
			var buttonIconId = "rubar-popupmenu-button-icon" + this.level + "_" + index;
			var $li = $$( "<li />" )
				.data( "item.menu", item )
				.appendTo( ul );
			if (item.label == ''){
					$li.addClass('tbui-menu-item-separator')
			} else {
				var $a = $$( "<a />" )
					.append( $$( "<div />" )
						.attr("id", buttonIconId)
						.addClass('rubar-menu-item-icon')
					)
					.append($$('<p />')
						.text( item.label)
						.addClass('rubar-button-caption')
					)
					.attr("title", item.hint)
					.css({height:'24px'})
					.appendTo( $li );
					
				var $button = $$('<div />')
					.addClass('rubar-button-icon-empty')
					.appendTo($a);
				if (item.icon != '') {
					loadBinContent(buttonIconId, 'data/packages/' + guid + '/' + item.icon);
				}
				if (item.link != '') {
					$li.click(function() {
						//alert(item.link);
						rubar.browser.openUILink(item.link);
					});
				}
				if (item.submenu.length > 0) {
					$button.addClass('rubar-button-icon-right');
					var $subMenu = $li.popupSubMenu({
						menu: item.submenu,
						level: this.level + 1,
						index: 1,
						guid: guid
					});
				}
				$li.hover(function() {
					$$("ul[level=2]").hide();
					if (item.submenu.length > 0) {
						$subMenu.popupSubMenu('open');
					}
				},
				function() {
				});
			}
			return $li;
		}
	});
})( $$ );
};