// ==UserScript==
// @name        Test
//
// @include     http://*rubar*
// @include     http://*softomate*

// ==/UserScript==
(function() {
	var $ = this;
	var external = {};
	var fnCallbacks = {};
	this.log = function(arg) {
		//console.log(arg);
	}
	// asynchronous messages from background
	var onMessage = function(event) {
		if (!event || !event.data || !event.data.action)
			return;	
		$.log("injected script action = " + event.data.action);
		var name = event.data.name;
		switch(event.data.action) {
			case 'ruBar_getCookieVar':
				if (typeof fnCallbacks['ruBar_cookie_' + name ] != 'undefined') {
					fnCallbacks['ruBar_cookie_' + name](event.data.value);
					delete fnCallbacks['ruBar_cookie_' + name];
				}
				return;
			case 'ruBar_eventListener':
				if (typeof fnCallbacks['ruBar_addEventListener_' + name ] != 'undefined') {
					fnCallbacks['ruBar_addEventListener_' + name](event.data.value);
				}
				return;
		}
	};
	opera.extension.addEventListener('message', onMessage, false);
	// XmlHttpRequest
	function _XmlHttpRequest() {
		var options= {
				id: Math.floor(Math.random()*1000001),
				method: 'GET',
				url: '',
				headers: [],
				params:''
			}, 
			self = this,
			responseHeaders = null;
		this.__defineGetter__("id", function(){
			return options.id;
		})
		function fnSuccess(event) {
			if (event.data.action = 'xmlHttpRequest') {
				opera.extension.removeEventListener('message', fnSuccess, false);
				var resp = event.data;
				if (resp.xhr.responseXML == null) {
					var parser = new window.DOMParser();
					resp.xhr.responseXML = parser.parseFromString(resp.xhr.responseText, "text/xml");
				}
				for(var x in resp.xhr)
					self[x] = resp.xhr[x];
				responseHeaders = resp.headers;
				self.onreadystatechange();
			}
		}
		this.open = function(method, url){
			options.method = method;
			options.url = url;
		};
		this.setRequestHeader = function(name, value) {
			options.params.push({name: name, value: value});
		};
		this.send = function(data){
			options.data = data ? data : "";
			opera.extension.postMessage({
				action: 'ruBar_xmlHttpRequest',
				request: options
			});
			opera.extension.addEventListener('message', fnSuccess, false);
		};
		this.abort = function() {		
		};
		this.getAllResponseHeaders = function() {
			return responseHeaders;
		}
		this.getResponseHeader = function(name)	{
			var splt = responseHeaders.split("\n");
			for(var x in splt) {
				var header = splt[x].split(": ");
				if (header[0].toLowerCase() == name.toLowerCase()) {
					return header[1];
				}	
			}
			return null;
		}
			
		this.onreadystatechange = null;
	}
	external.openPopupWindow = function(url, width, height, left) {
		$.log('ruBar WinAPI openPopupWindow');
		if ("undefined" == typeof(left)) {
			var hash = window.location.hash;
			if (hash.charAt(0) == "#")
				hash = hash.substring(1);
			left = JSON.parse(hash).left;
		}
		opera.extension.postMessage({
			action:	"ruBar_openPopupWindow",
			options: {
				url:	url,
				width:	width,
				height:	height,
				x: 	left
			}
		});
	};
     
	external.setCookie = function(name, value, domain, expiredate) {
		$.log('ruBar WinAPI setCookie');
		opera.extension.postMessage({
			action:		"ruBar_setCookie",
			value:		value,
			name:		name,
			//domain:	domain,
			expiredate:	expiredate
		});
		return true;
	};
     
	external.getCookie = function(name, fnCallBack) {
		$.log('ruBar WinAPI getCookie');
		opera.extension.postMessage({
			action:	'ruBar_getCookie',
			name:	name
		});
		fnCallbacks['ruBar_cookie_' + name] = fnCallBack;
	};
     
	external.addRubarEventListener = function(eventname, func) {
		$.log('ruBar WinAPI addRubarEventListener');
		opera.extension.postMessage({
			action:		'ruBar_addEventListener',
			eventname:	eventname
		});
		fnCallbacks['ruBar_addEventListener_' + eventname] = func;
		return false;
    };
     
	external.removeRubarEventListener = function(eventname, func) {
		$.log('ruBar WinAPI removeRubarEventListener');
		opera.extension.postMessage({
			action:		'ruBar_removeEventListener',
			eventname:	eventname
		});
		if (typeof(fnCallbacks['ruBar_addEventListener_' + eventname]) != 'function') {
			delete fnCallbacks['ruBar_addEventListener_' + eventname];
		}
		return false;
	};
     
	external.getCurrentTabUrl = function() {
		$.log('ruBar WinAPI getCurrentTabUrl');
		var hash = window.location.hash;
		if (hash.charAt(0) == "#")
			hash = hash.substring(1);
		baseUrl = JSON.parse(hash).url;
		return baseUrl;
	};
     
	external.sendRubarCrossDomainRequest = function(url, method, body, callback) {
		$.log('ruBar WinAPI sendRubarCrossDomainRequest');
		var xhr = new _XmlHttpRequest();
		
        xhr.open(method, url);
        xhr.onreadystatechange = function() {
			if (xhr.readyState == 4)
				callback(xhr.responseText, xhr.status);
        }
        xhr.send(body);
	};
     
	external.ruNavigate = function(url, options) {
		$.log('ruBar WinAPI ruNavigate');
		opera.extension.postMessage({
			action:		"ruBar_ruNavigate",
			url: 		url,
			options:	options
		});
	};

    external.setControlWidth = function(controlname, width) {
		$.log('ruBar WinAPI setControlWidth');
		opera.extension.postMessage({
			action : "ruBar_setControlWidth",
			controlname : controlname,
			width : width
		});
	};
     
	external.setRubarRegistryItem = function(name, data) {
		$.log('ruBar WinAPI setRubarRegistryItem No registry access!');
		return false;
	};
     
	external.getRubarRegistryItem = function(name) {
		$.log('ruBar WinAPI getRubarRegistryItem No registry access!');
		return false;
    };
     
    external.removeRubarRegistryItem = function(name) {
		$.log('ruBar WinAPI removeRubarRegistryItem No registry access!');
		return false;
    };
     
    external.sendControlRequest = function(controlname, data, callback) {
		$.log('ruBar WinAPI sendControlRequest');
		//return $._sendControlRequest(controlname, data, callback);
    };
     
    external.onControlRequestListener = function(listener) {
		if (external._RubarRequestListener == null) {
			external._RubarRequestListener = listener;
		}
	};
  
	$._sendControlRequest = function(controlname, data, callback) {
		/*let browsers = $.Toolbar.self.getElementsByTagName("browser");
		for (let i = 0; i < browsers.length; i++) {
			let browser = browsers[i];        
			if (callback != null && controlname != null && browser.getAttribute("id") != controlname)
				continue;
          
			if (browser.contentWindow.wrappedJSObject._RubarRequestListener == null)
				continue;
        
			let result = browser.contentWindow.wrappedJSObject._RubarRequestListener((callback == null) ? controlname : data);

			if (result != null)
				(callback == null) ? data(result) : callback(result);
		}*/
	};
	
	window.external = external;
})();