﻿window.addEventListener("load", function() {
	var layoutText = null,
		layoutXml = null;
	var cash = {};
	var rubar = rubar || {browser: new Browser()};
	rubar.extension = new Extension();
	rubar.ui = rubar.ui || {};
	rubar.ui.toolbar = new Toolbar();
	rubar.ui.button = new Button();
	var cookiePort;
	var eventListenetPort = {};
	function loadTextData(path) {
		var req = new XMLHttpRequest();
		req.open('GET', path, false);
		req.send();
		if (!req.responseText) {
			opera.postError('EXTENSION ERROR: Can\'t read ' + path);
			return '';
		}
		return req.responseText;
	}
	(function(){
		layoutText = loadTextData('data/layout.xml');
		layoutXml = $.parseXML(layoutText);
		var $layoutXml = $(layoutXml);
		var $layouts = $layoutXml.find("layout");
		$.each($layouts.children(), function(i, item) {
			if (this.nodeName == 'separator')
				rubar.toolbar.newSeparator(i);
			else {
				var type = $(this).find('type').text();
				var guid = $(this).find('guid').text();
				// load package
				// config.xml
				var config = loadTextData('data/packages/' + guid + '/config.xml')
				config = config.replace(/<\\?.*\\?>/, '');
				
				if( type == 'mail' && config.indexOf( '<menuitems>' ) == -1 )
				{
					//add mailers to config, if absent
					var items_xml_str = '<menuitems><item text="Яндекс.Почта" link="http://mail.yandex.ru/neo2/"/><item text="Gmail" link="http://gmail.com"/><item text="Mail.ru" link="http://mail.ru"/><item text="" /></menuitems>';
					config = config.replace( /<\/button>/im, items_xml_str + '</button>' );
				}
				
				// loader.js
				var loader = loadTextData('data/packages/' + guid + '/loader.js');
				loader = loader.replace(/\$\$/g, '**');
				// add guid to layoutText
				config = config.replace(/<button>/i, '<button>\r\t<guid>' + guid + '</guid>\r\t<script><![CDATA[' + loader + ']]></script>');
				layoutText = layoutText.replace(new RegExp("<button>\\s*<guid>" + guid + "</guid>(.|\\s|\\r|\\n|\\t)*?</button>", "i"), config);
			}
		});
		layoutText = layoutText.replace(new RegExp('[*][*]', 'g'), '\$\$\$\$');
	})();
	//console.log("layoutText = " + layoutText);
	
	opera.extension.onmessage = function(event) {
		if (!event || !event.data || !event.data.action)
			return;
		
		var msg = event.data;
		//console.log(msg.action);
		switch(msg.action) {
			case 'rubar_browser_navigate' :
				rubar.browser.navigate(msg.url, msg.newtab);
				return;
			case 'rubar_browser_setStyle' :
				rubar.browser.setStyle(msg.url, msg.style);
				return;
			case 'rubar_tb_close':
				rubar.ui.toolbar.showTooblarTrigger();
				return;
			case 'rubar_browser_setStyle' :
				rubar.browser.setStyle(msg.url, msg.style);
				return;
			case 'LoadInjectedCSS':
				loadInjectedCSS(event, msg.data);
				return;
			case 'rubar_loadContent':
				loadContent(event);
				return;
			case 'rubar_loadTextContent':
				loadTextContent(event);
				return;
			case 'rubar_loadBinContent':
				loadBinContent(event);
				return;
			case 'ruBar_setControlWidth':
				opera.extension.tabs.getFocused().postMessage({
					action: 'ruBar_setControlWidth',
					controlname: msg.controlname,
					width: msg.width
				});
				return;
			case 'ruBar_ruNavigate':
				var newtab = false;
			    //if (msg.options == null || msg.options == "current")
				//	newtab = false;
				if (msg.options == "newtab")
					newtab = true;
				if (msg.options == "newwindow")
					newtab = true;
				rubar.browser.navigate(msg.url, newtab);
				return;
			case 'ruBar_setCookie':
				opera.extension.tabs.getFocused().postMessage({
					action: 	'ruBar_setCookie',
					name: 		msg.name,
					value: 		msg.value,
					expiresDate: msg.expiresDate
				});
				return;
			case 'ruBar_getCookie':			// from IFRAME
				cookiePort = event.source;
				opera.extension.tabs.getFocused().postMessage({
					action: 'ruBar_getCookie',
					name: 	msg.name
				});
				return;
			case 'ruBar_getCookieVar':		// to IFRAME
				cookiePort.postMessage({
					action: 'ruBar_getCookieVar',
					name: 	msg.name,
					value: 	msg.value
				});
				cookiePort = null;
				return;
			case 'ruBar_openPopupWindow':
				rubar.ui.toolbar.showTooblarPopup(msg.options, opera.extension.tabs.getFocused());
				return;
			case 'ruBar_addEventListener':
				opera.extension.broadcastMessage({
					action: 'ruBar_addEventListener',
					name: 	msg.eventname
				});
				return;
			case 'ruBar_eventListener':
				opera.extension.broadcastMessage({
					action: 'ruBar_eventListener',
					name: 	msg.name,
					value:	msg.value
				});
				return;
			case 'ruBar_removeEventListener':
				opera.extension.broadcastMessage({
					action: 'ruBar_removeEventListener',
					name: 	msg.eventname
				});
				return;
			case 'ruBar_xmlHttpRequest':
				rubar.extension.xmlHttpRequest(event.source, msg);
				return;
			case 'ruBar_setInterval':
				setInterval(msg.name, msg.interval);
				return;
			case 'ruBar_widgetRequest':
				if(plugins && plugins[msg.widget]){
					var Port = event.source;
					plugins[msg.widget].apply(msg.data, function(data){
						Port.postMessage({
							'action': 'ruBar_widgetResponse',
							'widget': 	msg.widget,
							'id': 		msg.id,
							'data':	 	data
						});
					});
				}
		}
	}
	var popupSize = {width: 110, height: 40};
	var ToolbarUIItemProperties = {
		title: "Показать/Скрыть тулбар",
		icon: "favicon.png",
		popup: {
			width: 	popupSize.width,
			height:	popupSize.height
		}
	}
	showButton();
	
	function setInterval(name, interval) {
		window.setInterval(function() {
			opera.extension.broadcastMessage({
				action: 'ruBar_setInterval',
				name: 	name
			});
		}, interval);
	}
	function showButton() {
		if (window.widget.preferences.button != '0') {
			theButton.title = "Показать/Скрыть тулбар";
			theButton.icon = "favicon.png";			
			opera.contexts.toolbar.addItem(theButton);			
		}
		else if (theButton)	{
			opera.contexts.toolbar.removeItem(theButton);
		}
	}
	function loadTextContent(event) {
		var path = event.data.path;
		var data = null;
		if ('undefined' == typeof cash[path]) {
			var req = new XMLHttpRequest();
			req.open('GET', path, false);
			req.send();
			
			if (!req.responseText) {
				opera.postError('EXTENSION ERROR: Can\'t read ' + path);
				return;
			}
			data = req.responseText;
			cash[path] = data;
		} else {
			data = cash[path];
		}
		event.source.postMessage({
			action: 'rubar_loadTextContent',
			content: data,
			name: event.data.name
		});
	}
	function loadBinContent(event) {
		var path = event.data.path;
		var data = null;
		if ('undefined' == typeof cash[path]) {
			var req = new XMLHttpRequest();
			req.open('GET', path, false);
			req.overrideMimeType("text/plain; charset=x-user-defined");
			req.send();
			
			if (!req.responseText) {
				opera.postError('EXTENSION ERROR: Can\'t read ' + path);
				return;
			}
			/*var resp = req.responseText;
			var newResp = [];
			for (var z = 0; z < resp.length; z++) {
				newResp[z] = String.fromCharCode(resp.charCodeAt(z) & 255);
			}
			newResp = newResp.join("");*/
			data = btoa(req.responseText)
			cash[path] = data;
		} else {
			data = cash[path];
		}
		event.source.postMessage({
			action: 'rubar_loadBinContent',
			//content: Base64.encode(newResp),
			content: data,
			id: event.data.id
		});
	}
	function loadInjectedCSS(event, path) {
		// Try to get the contents of the stylesheet.
		var req = new XMLHttpRequest();
		req.open('GET', path, false);
		req.send();
		
		if (!req.responseText) {
			opera.postError('EXTENSION ERROR: Can\'t read ' + path);
			return;
		}
		event.source.postMessage({
			action: 'css',
			data: {
				css: req.responseText,
				path: path
			}
		});
	}
	function loadContent() {
		event.source.postMessage({
			action: 'rubar_showContent',
			xml: layoutText
		});	
	}
}, false);
function fixBoolPref(name) {
	if (name == "false")
		return false;
	if (name == "true")
		return true;
	return name;
}