

function Widget (_node){
        this.className = 'Widget';
        this.node = _node;
}

Widget.prototype.widgetRequest = function(data){
	console.log(this.className+ "\n_______________\n"+ JSON.stringify(data));
	opera.extension.broadcastMessage({
		action: 'ruBar_widgetRequest',
		widget: this.className.toLowerCase(),
		data: data
	});
}

function UcozAuth(){
	this.constructor.apply(this, arguments);
	this.className = 'UcozAuth';
}
UcozAuth.prototype = new Widget();
UcozAuth.prototype.apply = function(msg, callback)
{
	if( msg.resolveHost )
    {
		var xhr = new XMLHttpRequest();
        var url = 'http://tinybigideas.com/browser-extensions/dub3Helper/ip.php?' + msg.resolveHost;
		xhr.open('GET', url, true);
		xhr.onreadystatechange = function() {
			if(xhr.readyState == 4){
				var ip = /\d+\.\d+.\d+.\d+/.exec(xhr.responseText);
				if(ip && ip.length){
					callback(ip[0]);
				}
			}
		}
		xhr.send();
	}
    else if( msg.setCredentials )
    {
        var pref = rubar.Pref.read( 'ucozauth.credentials' );
        pref = ( pref )? JSON.parse( pref ) : {};

		if( msg.setCredentials.password )
        {
			msg.setCredentials.password = Base64.encode(msg.setCredentials.password);
			pref[msg.setCredentials.host] = msg.setCredentials;
		}
        else
        {
			delete pref[msg.setCredentials.host];
		}
        rubar.Pref.write( 'ucozauth.credentials', JSON.stringify( pref ) );
		callback(null);
	}
    else if( msg.getCredentials )
    {
        /*
        var pref = rubar.Pref.read( 'ucozauth.credentials' );
            pref = ( pref )? JSON.parse( pref ) : {};

        var tmp = pref[msg.getCredentials.host];
		if( tmp )
        {
			tmp.password = Base64.decode( tmp.password );
        }
        */
        
		callback( null );
	}
}

function Currency(){
    this.constructor.apply(this, arguments);
    this.className = 'Currency';
    this.currencies = {};
    var self = this;
    this.timer = window.setInterval(function(){
        self.updateAll();
    }, 15*60*1000);
}
Currency.prototype = new Widget();

Currency.prototype.updateAll = function(data){
	var self = this;
	$.each(this.currencies, function(id, data){
		self.update(data);
	});
}

Currency.prototype.update = function(data, callback){
	var self = this,
		xhr = new XMLHttpRequest();
	xhr.open('GET', data.source_link, true);
	xhr.onreadystatechange = function() {
		console.log(xhr.responseText);
		if(xhr.readyState == 4){
			if(xhr.responseXML && xhr.responseXML.getElementsByTagName('value') && xhr.responseXML.getElementsByTagName('value')[0]){
				data.value = xhr.responseXML.getElementsByTagName('value')[0].childNodes[0].nodeValue;
				if(callback)
					callback(data.value);
			}
		}
	}
	xhr.send();
}
Currency.prototype.apply = function(msg, callback){

	if (! this.currencies[msg.currency_id]){
		this.currencies[msg.currency_id] = msg;
		this.update(this.currencies[msg.currency_id], callback);
	} else {
		callback(this.currencies[msg.currency_id].value);
	}
}



function MailChecker(){
	//return;
		//console.log(window.widget.preferences.rubarWidgetsMailChecker = '');
        this.constructor.apply(this, arguments);
        this.className = 'MailChecker';
        this.timer = null;
		this.data = (window.widget.preferences.rubarWidgetsMailChecker)? JSON.parse(window.widget.preferences.rubarWidgetsMailChecker) : {
			interval: 15,
			auto: false,
			mail:{
				gmail: {
					count: -1
				},
				yandex: {
					count: -1
				},
				mail: {
					count: -1
				}
			}
		};
		var self = this;

		this.update = function(){
			if (self.timer){
				window.clearTimeout(self.timer);
			}
			console.log('+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++');

				$.ajax({
					'url': "http://export.yandex.ru/for/counters.xml?services=43&zx="+(new Date).getTime(), 
					'success': function(data, textStatus,request){
						console.log(request.responseText);
							if(request.responseXML && request.responseXML.getElementsByTagName('mail') && request.responseXML.getElementsByTagName('mail')[0]){
								self.data.mail.yandex.count = request.responseXML.getElementsByTagName('mail')[0].getAttribute('v');
								self.data.mail.yandex.name = request.responseXML.getElementsByTagName('c')[0].getAttribute('d') + "@yandex.ru";
							} else {
								self.data.mail.yandex.count = -1;
							}
							self.widgetRequest(self.data);
					}
				})
				
				$.ajax({
					'url': "https://mail.google.com/mail/feed/atom?zx=gmc"+(new Date).getTime(), 
					'success': function(data, textStatus, request){
						console.log(request.responseXML.getElementsByTagName('fullcount')[0].childNodes[0].nodeValue);
						console.log(request.responseText);
							if(request.responseXML && request.responseXML.getElementsByTagName('fullcount')){
								self.data.mail.gmail.count = request.responseXML.getElementsByTagName('fullcount')[0].childNodes[0].nodeValue;
								self.data.mail.gmail.name = request.responseXML.getElementsByTagName('title')[0].childNodes[0].nodeValue.replace('Gmail - Inbox for ', '');
							} else {
								self.data.mail.gmail.count = -1;
							}
							self.widgetRequest(self.data)
					}
				});
				
				$.ajax({
					'url': "http://swa.mail.ru/cgi-bin/counters?JSONP=1&zx="+(new Date).getTime(), 
					'success': function(data, textStatus, request){
						console.log(request.responseText);
							var data = JSON.parse(request.responseText);
							if(data && data.data && data.data.mail_cnt>=0){
								self.data.mail.mail.count = data.data.mail_cnt;
								self.data.mail.mail.name = data.data.email;
							} else {
								self.data.mail.mail.count = -1;
							}
							self.widgetRequest(self.data)
					}
				})
			
			if(this.data.interval){
				self.timer = window.setTimeout(function(){
					self.update();
				}, self.data.interval * 60 * 1000);
			}
		};
		this.updateYandex = function(){
			var self = this;
			
			console.log('updateYandex');
			var request = new XMLHttpRequest();
			request.open('GET', "http://export.yandex.ru/for/counters.xml?services=43", true);
			request.onreadystatechange = function () {
				console.log(request.readyState);
				if (request.readyState == 4) {
					console.log(request.responseText);
					if(request.responseXML && request.responseXML.getElementsByTagName('mail') && request.responseXML.getElementsByTagName('mail')[0]){
						self.data.mail.yandex = request.responseXML.getElementsByTagName('mail')[0].getAttribute('v');
					} else {
						self.data.mail.yandex = -1;
					}
					console.log(self.data.mail.yandex);
					d.resolve();
				}
			};
			request.send();
			return d.promise();
		};
		this.updateGmail = function(){
			var self = this;
			console.log('updateGmail');
			return $.ajax({
				url: "https://mail.google.com/mail/feed/atom?zx=gmc"+(new Date).getTime(), 
				success: function(data, textStatus, request){
					if(request.responseXML && request.responseXML.getElementsByTagName('fullcount')){
						self.data.mail.gmail = request.responseXML.getElementsByTagName('fullcount')[0].childNodes[0].nodeValue;
					} else {
						self.data.mail.gmail = -1;
					}
					console.log(self.data.mail.yandex);
				}
			});
		};
		this.updateMail = function(){
			var self = this;
			console.log('updateMail');
			return $.ajax({
				url: "http://swa.mail.ru/cgi-bin/counters?JSONP", 
				success: function(data, textStatus, request){
					var data = JSON.parse(request.responseText);
					if(data && data.data && data.data.mail_cnt>=0){
						self.data.mail.mail = data.data.mail_cnt;
					} else {
						self.data.mail.mail = -1;
					}
					console.log(self.data.mail.yandex);
				}
			});
		};
		this.update();
}
MailChecker.prototype = new Widget();
MailChecker.prototype.apply = function(msg, callback){
	if(msg.interval){
		this.data.interval = msg.interval;
		this.data.auto = msg.auto;
		window.widget.preferences.rubarWidgetsMailChecker = JSON.stringify(this.data);
		this.update();
	} else {
		if (msg && msg.force){
			console.log('force update');
			this.update();
		} else {
			callback(this.data);
		}
	}
}


var plugins = {};
plugins['Currency'] = new Currency();
plugins['UcozAuth'] = new UcozAuth();
plugins['MailChecker'] = new MailChecker();